<?php
/*
** 99ko
** Jonathan Coulet
** j.coulet@gmail.com
** http://www.99ko.org


** Variables principales
** -------------------------------------------
** $temps_exe => résultat du temps d'execution du script
** $version => version de 99ko
** $config ( array ) => tableau des données de configuration
** $pages ( array ) => tableau de données des pages
** $module => module appelé ( $_GET[0] )
** $meta_title = >meta title de la page
** $meta_desc => meta description de la page
** $menu_pages => ( bool ) permet de masquer / afficher le menu des pages
** $sidebar => ( bool ) permet de masquer / afficher la sidebar
** $template => fichier a inclure dans base.php
*/

session_start();
$temps_exe = microtime();
include('99ko.lib.php');
$version = '0.2b';

/*
** Fix
*/

// Magic quotes
if(get_magic_quotes_gpc()){
	function stripslashes_deep($value){
		$value = is_array($value) ? array_map('stripslashes_deep', $value) : stripslashes($value);
		return $value;
	}
	$_POST = array_map('stripslashes_deep', $_POST);
	$_GET = array_map('stripslashes_deep', $_GET);
	$_COOKIE = array_map('stripslashes_deep', $_COOKIE);
	$_REQUEST = array_map('stripslashes_deep', $_REQUEST);
}
if(get_magic_quotes_runtime()){
	set_magic_quotes_runtime(0);
}

/*
** Reconstruction de $_GET
*/
if($_SERVER['QUERY_STRING'] != ''){
	// Avant le premier slash = module
	$_GET[0] = substr($_SERVER['QUERY_STRING'], 0, strpos($_SERVER['QUERY_STRING'], '/'));
	// Les autres paramètres
	foreach(explode(',', substr($_SERVER['QUERY_STRING'], strpos($_SERVER['QUERY_STRING'], '/')+1)) as $k=>$v){
		if($v != ''){ $_GET[$k+1] = $v; }
	}
}

/*
** Installation ( création du fichier config )
*/
if(!file_exists('data/config.txt')){
	$data = "[mdp_admin|43514a20c7801ebd4b1e6769939dd95f]\n";
	$data .= "[nom_site|Nom du site]\n";
	$data .= "[theme|defaut]\n";
	$data .= "[desc_site|Un site propulsé par 99ko.]\n";
	@chmod('data/', 0777);
	if(!fp_contents('data/config.txt', $data)){
		echo "Erreur d'installation : Appliquez un CHMOD 0777 au répertoire data/ !";
		exit();
	}
}

/*
** Configutation
*/
$config = array();
preg_match_all('#\[(.*)\]#Usi', file_get_contents('data/config.txt'), $matches);
foreach($matches[1] as $k2=>$v){
	$temp = explode('|', $v);
	$config[$temp[0]] = $temp[1];
}
if(!isset($config['email_admin'])){ $config['email_admin'] = ''; } // Depuis la 0.2
if(!isset($config['mod_contact'])){ $config['mod_contact'] = 0; } // Depuis la 0.2

/*
** Pages
*/
$pages = array();
foreach(scandir('data/pages/') as $k=>$fichier){
	if($fichier[0] != '.' && $id = str_replace('.txt', '', $fichier)){
		preg_match_all('#\[(.*)\]#Usi', file_get_contents('data/pages/'.$fichier), $matches);
		foreach($matches[1] as $k2=>$ligne){
			$temp = explode('|', $ligne);
			$pages[$id][$temp[0]] = $temp[1];
		}
	}
}
$pages = tri_array($pages, 'ordre', 'num');
$pages = valeur_vers_cle($pages, 'id');
//print_r($pages);

/*
** Installation ( création de la page exemple )
*/
if(count($pages) < 1){
	$data = "[id|1]\n";
	$data .="[nom|Page d'exemple]\n";
	$data .="[ordre|1]\n";
	$data .="[homepage|1]\n";
	$data .="[contenu|Post hoc impie perpetratum quod in aliis quoque iam timebatur, tamquam licentia crudelitati indulta per suspicionum nebulas aestimati quidam noxii damnabantur. quorum pars necati, alii puniti bonorum multatione actique laribus suis extorres nullo sibi relicto praeter querelas et lacrimas, stipe conlaticia victitabant, et civili iustoque imperio ad voluntatem converso cruentam, claudebantur opulentae domus et clarae.]\n";
	@chmod('data/pages/', 0777);
	if(!fp_contents('data/pages/1.txt', $data)){
		echo "Erreur d'installation : Appliquez un CHMOD 0777 au répertoire data/pages/ !";
		exit();
	}
	header('location:?page/');
}

/*
** Données par défaut & execution du module
*/
$module = (isset($_GET[0])) ? $_GET[0] : 'page';
if($module != 'admin'){
	$meta_title = $config['nom_site'];
	$meta_desc = $config['desc_site'];
	$menu_pages = true;
	$sidebar = true;
	switch($module){
		case 'page':
			// Récupération de la page demandée ou de la homepage
			$page = (isset($_GET[1])) ? $pages[$_GET[1]] : extrait_array($pages, 'homepage', 1);
			// Balises meta
			if($page['homepage'] == 0){
				$meta_title = $config['nom_site'].' - '.$page['nom'];
				$meta_desc = '';
			}
			// La sidebar est inactive pour le moment...
			$sidebar = false;
			$template = 'page';
			break;
		case 'contact':
			if($config['mod_contact'] == 1){
				$msg = "Tous les champs sont obligatoires.";
				if(count($_POST) > 0){
					$nom = trim($_POST['nom']);
					$prenom = trim($_POST['prenom']);
					$email = trim($_POST['email']);
					$message = trim($_POST['message']);
					if(md5($_POST['captcha_reponse']) != $_SESSION['captcha_reponse_md5']){
						$msg = "La vérification antispam a échouée.";
					}
					elseif($nom == '' || $prenom == '' || $email == '' || $message == ''){
						$msg = "Tous les champs sont obligatoires.";
					}
					elseif(!valide_email($email)){
						$msg = "L'adresse e-mail est invalide.";
					}
					else{
						$headers ='From: "'.$prenom.' '.$nom.'"<'.$email.'>'."\n";
						$headers .='Reply-To: '.$email. "\n" .
						'X-Mailer: PHP/' . phpversion();
						if(!@mail($config['email_admin'], $config['nom_site'].' - Contact', $message, $headers)){
							$msg = "Le message n'a pas été envoyé car une erreur est survenue.";
						}
						else{
							$msg = "Le message a bien été envoyé.";
						}
					}
				}
				$captcha_a = rand(1,5);
				$captcha_b = rand(1,5);
				$_SESSION['captcha_reponse_md5'] = md5($captcha_a + $captcha_b);
				$sidebar = false;
				$template = 'contact';
			}
			break;
	}
	$temps_exe = round(microtime()-$temps_exe, 3);
	include('themes/'.$config['theme'].'/base.php');
}
// Administration
else{
	$menu_pages = true;
	$sidebar = true;
	if(!isset($_SESSION['admin']) || $_SESSION['admin'] != $config['mdp_admin']){
		$section = 'login';
	}
	elseif(isset($_GET[1])){
		$section = $_GET[1];
	}
	else{
		$section = 'page';
	}
	$action = (isset($_GET[2])) ? $_GET[2] : '';
	switch($section){
		case 'msg':
			$template = 'msg';
			break;
		case 'login':
			if($action == 'check'){
				$msg = '';
				if(md5($_POST['mdp']) != $config['mdp_admin']){
					$msg = "Mot de passe incorrect.";
				}
				if($msg == ''){
					$_SESSION['admin'] = md5($_POST['mdp']);
					@chmod('data/', 0777);
					@chmod('data/pages/', 0777);
				}
				header('location:?admin/');
				exit();
			}
			$menu_pages = false;
			$sidebar = false;
			$template = 'login';
			break;
		case 'exit':
			$_SESSION['admin'] = '';
			header('location:?page/');
			exit();
			break;
		case 'page':
			if($action == 'save'){
				$msg = '';
				// Préparation des données
				$id = (intval($_POST['id']) > 0) ? intval($_POST['id']) : max_cle_array($pages)+1;
				$nom = trim(remplace_caracteres_reserves($_POST['nom']));
				$ordre = intval($_POST['ordre']);
				$homepage = (isset($_POST['homepage'])) ? 1 : ((count($pages) < 2) ? 1 : 0); // Si c'est l'unique page elle est forcéé homepage
				$contenu = trim(remplace_caracteres_reserves($_POST['contenu']));
				// Contrôles
				if($nom == ''){
					$nom = "Page sans titre";
				}
				if($msg == ''){
					// Mise à jour de la homepage actuelle
					if($homepage == 1){
						$pagehome = extrait_array($pages, 'homepage', 1);
						if($pagehome['id'] != $id){
							$pages[$pagehome['id']]['homepage'] = 0;
							if(!enregistre($pages, 'data/pages/', $pagehome['id'])){
								$msg = "Une erreur d'écriture est survenue.";
							}
						}
					}
					if($msg == ''){
						// Mise à jour du tableau des pages
						$pages[$id] = array(
							'id' => $id,
							'nom' => $nom,
							'ordre' => $ordre,
							'homepage' => $homepage,
							'contenu' => $contenu,
						);
						// Enregistrement
						if(!enregistre($pages, 'data/pages/', $id)){
							$msg = "Une erreur d'écriture est survenue.";
						}
						else{
							$msg = "Les modifications ont bien été enregistrées.";
						}
					}
				}
				// Redirection
				header('location:?admin/msg,'.urlencode($msg));
				exit();
			}
			elseif($action == 'del'){
				$page = $pages[$_GET[3]];
				if($page['homepage'] == 1){
					$msg = "Impossible de supprimer la page d'accueil.";
				}
				elseif(count($pages) < 2){
					$msg = "Impossible de supprimer l'unique page.";
				}
				if($msg == ''){
					if(unlink('data/pages/'.$page['id'].'.txt')){
						unset($pages[$page['id']]);
						$msg = "Les modifications ont bien été enregistrées.";
					}
					else{
						$msg = "Une erreur d'écriture est survenue.";
					}
				}
				header('location:?admin/msg,'.urlencode($msg));
				exit();
			}
			elseif($action == 'edit'){
				if(isset($_GET[3])){
					$page = $pages[$_GET[3]];
				}
				else{
					$ordre = max(extrait_valeurs_array($pages, 'ordre'))+1;
				}
				$template = 'page_edit';
			}
			else{
				$template = 'page';
			}
			break;
		case 'config':
			if($action == 'save'){
				$msg = '';
				// Préparation des données
				$mdp_admin = (trim(remplace_caracteres_reserves($_POST['mdp_admin'])) != '') ? trim(remplace_caracteres_reserves($_POST['mdp_admin'])) : '';
				$mdp_admin_md5 = ($mdp_admin == '') ? $config['mdp_admin'] : md5($mdp_admin);
				$nom_site = trim(remplace_caracteres_reserves($_POST['nom_site']));
				$theme = $_POST['theme'];
				$desc_site = trim(remplace_caracteres_reserves($_POST['desc_site']));
				$mod_contact = (isset($_POST['mod_contact'])) ? 1 : 0;
				$email_admin = trim($_POST['email_admin']);
				// Contrôles
				if($nom_site == ''){
					$msg = "Veuillez remplir les champs obligatoires.";
				}
				if($mdp_admin != '' && mb_strlen($mdp_admin) < 6){
					$msg = "Le mot de passe admin doit être composé de 6 caractères minimum.";
				}
				if($mod_contact == 1 && !valide_email($email_admin)){
					$msg = "Le formulaire de contact ne peut pas être activé car l'adresse e-mail administrateur est invalide.";
				}
				// Mise à jour du tableau $config
				$config['mdp_admin'] = $mdp_admin_md5;
				$config['nom_site'] = $nom_site;
				$config['theme'] = $theme;
				$config['desc_site'] = $desc_site;
				$config['mod_contact'] = $mod_contact;
				$config['email_admin'] = $email_admin;
				// Fix : deconnection après changement du mot de passe
				$_SESSION['admin'] = $config['mdp_admin'];
				// Enregistrement
				if($msg == ''){
					if(!enregistre($config, 'data/', 'config')){
						$msg = "Une erreur d'écriture est survenue.";
					}
					else{
						$msg = "Les modifications ont bien été enregistrées.";
					}
				}
				// Redirection
				header('location:?admin/msg,'.urlencode($msg));
				exit();
			}
			$themes = array();
			foreach(scandir('themes/') as $k=>$v){
				if('themes/'.is_dir($v[0]) && $v[0] != '.'){
					$themes[] = $v;
				}
			}
			$template = 'config';
			break;
	}
	$temps_exe = round(microtime()-$temps_exe, 3);
	include('admin/base.php');
}
?>